<?php
/**
 * Fashion Designer Studio functions and definitions
 *
 * @subpackage Fashion Designer Studio
 * @since 1.0
 */


// theme sewtup
function fashion_designer_studio_setup() {
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "wp-block-styles" );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( "responsive-embeds" );
	add_theme_support( 'title-tag' );
	add_theme_support('custom-background',array(
		'default-color' => 'ffffff',
	));
	add_image_size( 'fashion-designer-studio-featured-image', 2000, 1200, true );
	add_image_size( 'fashion-designer-studio-thumbnail-avatar', 100, 100, true );

	define( 'THEME_DIR', dirname( __FILE__ ) );

	load_theme_textdomain( 'fashion-designer-studio', get_template_directory() . '/languages' );

	$GLOBALS['content_width'] = 525;
	register_nav_menus( array(
		'primary' => __( 'Primary Menu', 'fashion-designer-studio' ),
	) );

	add_theme_support( 'html5', array(
		'comment-form',
		'comment-list',
		'gallery',
		'caption',
	) );

	// Add theme support for Custom Logo.
	add_theme_support( 'custom-logo', array(
		'width'       => 250,
		'height'      => 250,
		'flex-width'  => true,
		'flex-height'  => true,
	) );

	// Add theme support for selective refresh for widgets.
	add_theme_support( 'customize-selective-refresh-widgets' );
	/*
	 * Enable support for Post Formats.
	 *
	 * See: https://codex.wordpress.org/Post_Formats
	 */
	add_theme_support( 'post-formats', array('image','video','gallery','audio','quote',) );
	/*
	 * This theme styles the visual editor to resemble the theme style,
	 * specifically font, colors, and column width.
 	 */
	add_editor_style( array( 'assets/css/editor-style.css', fashion_designer_studio_fonts_url() ) );

	if ( ! defined( 'FASHION_DESIGNER_STUDIO_SUPPORT' ) ) {
	define('FASHION_DESIGNER_STUDIO_SUPPORT',__('https://wordpress.org/support/theme/fashion-designer-studio','fashion-designer-studio'));
	}
	if ( ! defined( 'FASHION_DESIGNER_STUDIO_REVIEW' ) ) {
	define('FASHION_DESIGNER_STUDIO_REVIEW',__('https://wordpress.org/support/theme/fashion-designer-studio/reviews/','fashion-designer-studio'));
	}
	if ( ! defined( 'FASHION_DESIGNER_STUDIO_LIVE_DEMO' ) ) {
	define('FASHION_DESIGNER_STUDIO_LIVE_DEMO',__('https://trial.ovationthemes.com/fashion-designer-studio/','fashion-designer-studio'));
	}
	if ( ! defined( 'FASHION_DESIGNER_STUDIO_BUY_PRO' ) ) {
	define('FASHION_DESIGNER_STUDIO_BUY_PRO',__('https://www.ovationthemes.com/products/designer-studio-wordpress-theme','fashion-designer-studio'));
	}
	if ( ! defined( 'FASHION_DESIGNER_STUDIO_PRO_DOC' ) ) {
	define('FASHION_DESIGNER_STUDIO_PRO_DOC',__('https://trial.ovationthemes.com/docs/ot-fashion-designer-studio-pro-doc/','fashion-designer-studio'));
	}
	if ( ! defined( 'FASHION_DESIGNER_STUDIO_FREE_DOC' ) ) {
	define('FASHION_DESIGNER_STUDIO_FREE_DOC',__('https://trial.ovationthemes.com/docs/ot-fashion-designer-studio-free-doc/','fashion-designer-studio'));
	}
	if ( ! defined( 'FASHION_DESIGNER_STUDIO_THEME_NAME' ) ) {
	define('FASHION_DESIGNER_STUDIO_THEME_NAME',__('Premium Designer Theme','fashion-designer-studio'));
	}
	if ( ! defined( 'FASHION_DESIGNER_STUDIO_BUNDLE_LINK' ) ) {
	define('FASHION_DESIGNER_STUDIO_BUNDLE_LINK',__('https://www.ovationthemes.com/products/wordpress-bundle','fashion-designer-studio'));
	}

	require get_template_directory() . '/inc/dashboard/dashboard-settings.php';
	require get_template_directory() . '/inc/admin/theme-upsell.php';

	}
add_action( 'after_setup_theme', 'fashion_designer_studio_setup' );

//woocommerce//
//shop page no of columns
function fashion_designer_studio_woocommerce_loop_columns() {
	
	$retrun = get_theme_mod( 'fashion_designer_studio_archieve_item_columns', 3 );
    
    return $retrun;
}
add_filter( 'loop_shop_columns', 'fashion_designer_studio_woocommerce_loop_columns' );
function fashion_designer_studio_woocommerce_products_per_page() {

		$retrun = get_theme_mod( 'fashion_designer_studio_archieve_shop_perpage', 6 );
    
    return $retrun;
}
add_filter( 'loop_shop_per_page', 'fashion_designer_studio_woocommerce_products_per_page' );
// related products
function fashion_designer_studio_related_products_args( $args ) {
    $defaults = array(
        'posts_per_page' => get_theme_mod( 'fashion_designer_studio_related_shop_perpage', 3 ),
        'columns'        => get_theme_mod( 'fashion_designer_studio_related_item_columns', 3),
    );

    $args = wp_parse_args( $defaults, $args );

    return $args;
}
add_filter( 'woocommerce_output_related_products_args', 'fashion_designer_studio_related_products_args' );

// breadcrumb seperator
function fashion_designer_studio_woocommerce_breadcrumb_separator($fashion_designer_studio_defaults) {
    $fashion_designer_studio_separator = get_theme_mod('woocommerce_breadcrumb_separator', ' / ');

    // Update the separator
    $fashion_designer_studio_defaults['delimiter'] = $fashion_designer_studio_separator;

    return $fashion_designer_studio_defaults;
}
add_filter('woocommerce_breadcrumb_defaults', 'fashion_designer_studio_woocommerce_breadcrumb_separator');

//add animation class
if ( class_exists( 'WooCommerce' ) ) { 
	add_filter('post_class', function($fashion_designer_studio_classes, $class, $product_id) {
	    if( is_shop() || is_product_category() ){
	        
	        $fashion_designer_studio_classes = array_merge(['wow','zoomIn'], $fashion_designer_studio_classes);
	    }
	    return $fashion_designer_studio_classes;
	},10,3);
}
//woocommerce-end//

function fashion_designer_studio_excerpt_enabled(){
	if(get_theme_mod('fashion_designer_studio_blog_meta_content') == 'Excerpt Content' ) {
		return true;
	}
	return false;
}

/* Excerpt Limit Begin */
function fashion_designer_studio_string_limit_words($string, $word_limit) {
	$words = explode(' ', $string, ($word_limit + 1));
	if(count($words) > $word_limit)
	array_pop($words);
	return implode(' ', $words);
}

// Admin scripts and styles
function fashion_designer_studio_enqueue_admin_script( $hook ) {
	wp_enqueue_style(
		'fashion-designer-studio-admin-style',
		get_template_directory_uri() . '/assets/css/admin-style.css'
	);
	wp_enqueue_script(
		'fashion-designer-studio-admin-js',
		get_theme_file_uri( '/assets/js/fashion-designer-studio-admin.js' ),
		array( 'jquery' ),
		'1.0.0',
		true
	);
	wp_localize_script(
		'fashion-designer-studio-admin-js',
		'fashion_designer_studio_localize',
		array(
			'ajax_url'      => admin_url( 'admin-ajax.php' ),
			'nonce'         => wp_create_nonce( 'fashion_designer_studio_dismissed_notice_nonce' ),
			'dismiss_nonce' => wp_create_nonce( 'fashion_designer_studio_dismissed_notice_nonce' ),
		)
	);
}
add_action( 'admin_enqueue_scripts', 'fashion_designer_studio_enqueue_admin_script' );

// tag count
function fashion_designer_studio_display_post_tag_count() {
    $fashion_designer_studio_tags = get_the_tags();
    $fashion_designer_studio_tag_count = ($fashion_designer_studio_tags) ? count($fashion_designer_studio_tags) : 0;
    $fashion_designer_studio_tag_text = ($fashion_designer_studio_tag_count === 1) ? 'tag' : 'tags';
    echo $fashion_designer_studio_tag_count . ' ' . $fashion_designer_studio_tag_text;
}

// Date formatting
function fashion_designer_studio_display_shop_date() {
    // Get the date type option
    $fashion_designer_studio_date_type = get_theme_mod( 'fashion_designer_studio_date_type', 'published' );

    // Determine the date to display based on the type
    if ( $fashion_designer_studio_date_type === 'modified' && get_the_modified_time( 'U' ) !== get_the_time( 'U' ) ) {
        $fashion_designer_studio_date_to_display = get_the_modified_date( get_option( 'date_format' ) );
    } else {
        $fashion_designer_studio_date_to_display = get_the_date( get_option( 'date_format' ) );
    }

    // Output the date HTML

    echo esc_html( $fashion_designer_studio_date_to_display );
}

//media post format
function fashion_designer_studio_get_media($fashion_designer_studio_type = array()){
	$fashion_designer_studio_content = apply_filters( 'the_content', get_the_content() );
  	$output = false;

  // Only get media from the content if a playlist isn't present.
  if ( false === strpos( $fashion_designer_studio_content, 'wp-playlist-script' ) ) {
    $output = get_media_embedded_in_content( $fashion_designer_studio_content, $fashion_designer_studio_type );
    return $output;
  }
}

// front page template
function fashion_designer_studio_front_page_template( $template ) {
	return is_home() ? '' : $template;
}
add_filter( 'frontpage_template',  'fashion_designer_studio_front_page_template' );

// excerpt function
function fashion_designer_studio_custom_excerpt() {
    $fashion_designer_studio_excerpt = get_the_excerpt();
    $fashion_designer_studio_plain_text_excerpt = wp_strip_all_tags($fashion_designer_studio_excerpt);
    
    // Get dynamic word limit from theme mod
    $fashion_designer_studio_word_limit = esc_attr(get_theme_mod('fashion_designer_studio_post_excerpt', '30'));
    
    // Limit the number of words
    $fashion_designer_studio_limited_excerpt = implode(' ', array_slice(explode(' ', $fashion_designer_studio_plain_text_excerpt), 0, $fashion_designer_studio_word_limit));

    echo esc_html($fashion_designer_studio_limited_excerpt);
}

// typography
function fashion_designer_studio_fonts_scripts() {
	$headings_font = esc_html(get_theme_mod('fashion_designer_studio_headings_text'));
	$body_font = esc_html(get_theme_mod('fashion_designer_studio_body_text'));

	if( $headings_font ) {
		wp_enqueue_style( 'fashion-designer-studio-headings-fonts', '//fonts.googleapis.com/css?family='. $headings_font );
	} else {
		wp_enqueue_style( 'fashion-designer-studio-playfair-sans', '//fonts.googleapis.com/css?family=Playfair Display:ital,wght@0,400;0,500;0,600;0,700;0,800;0,900;1,400;1,500;1,600;1,700;1,800;1,900');
	}
	if( $body_font ) {
		wp_enqueue_style( 'fashion-designer-studio-body-fonts', '//fonts.googleapis.com/css?family='. $body_font );
	} else {
		wp_enqueue_style( 'fashion-designer-studio-jost-body', '//fonts.googleapis.com/css?family=Jost:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900');
	}
}
add_action( 'wp_enqueue_scripts', 'fashion_designer_studio_fonts_scripts' );

// Footer Text
function fashion_designer_studio_copyright_link() {
    $fashion_designer_studio_footer_text = get_theme_mod('fashion_designer_studio_footer_text', esc_html__('Fashion Designer WordPress Theme', 'fashion-designer-studio'));
    $fashion_designer_studio_credit_link = esc_url('https://www.ovationthemes.com/products/free-fashion-designer-wordpress-theme');

    echo '<a href="' . $fashion_designer_studio_credit_link . '" target="_blank">' . esc_html($fashion_designer_studio_footer_text) . '<span class="footer-copyright">' . esc_html__(' By Ovation Themes', 'fashion-designer-studio') . '</span></a>';
}

// custom sanitizations
// dropdown
function fashion_designer_studio_sanitize_dropdown_pages( $page_id, $setting ) {
	$page_id = absint( $page_id );
	return ( 'publish' == get_post_status( $page_id ) ? $page_id : $setting->default );
}
// slider custom control
if ( ! function_exists( 'fashion_designer_studio_sanitize_integer' ) ) {
	function fashion_designer_studio_sanitize_integer( $input ) {
		return (int) $input;
	}
}
// range contol
function fashion_designer_studio_sanitize_number_absint( $number, $setting ) {

	// Ensure input is an absolute integer.
	$number = absint( $number );

	// Get the input attributes associated with the setting.
	$atts = $setting->manager->get_control( $setting->id )->input_attrs;

	// Get minimum number in the range.
	$min = ( isset( $atts['min'] ) ? $atts['min'] : $number );

	// Get maximum number in the range.
	$max = ( isset( $atts['max'] ) ? $atts['max'] : $number );

	// Get step.
	$step = ( isset( $atts['step'] ) ? $atts['step'] : 1 );

	// If the number is within the valid range, return it; otherwise, return the default
	return ( $min <= $number && $number <= $max && is_int( $number / $step ) ? $number : $setting->default );
}
// select post page
function fashion_designer_studio_sanitize_select( $input, $setting ){
    $input = sanitize_key($input);
    $choices = $setting->manager->get_control( $setting->id )->choices;
    return ( array_key_exists( $input, $choices ) ? $input : $setting->default );
}
// toggle switch
function fashion_designer_studio_callback_sanitize_switch( $value ) {
	// Switch values must be equal to 1 of off. Off is indicator and should not be translated.
	return ( ( isset( $value ) && $value == 1 ) ? 1 : 'off' );
}
//choices control
function fashion_designer_studio_sanitize_choices( $input, $setting ) {
    global $wp_customize;
    $control = $wp_customize->get_control( $setting->id );
    if ( array_key_exists( $input, $control->choices ) ) {
        return $input;
    } else {
        return $setting->default;
    }
}
// phone number
function fashion_designer_studio_sanitize_phone_number( $phone ) {
  return preg_replace( '/[^\d+]/', '', $phone );
}
// Sanitize Sortable control.
function fashion_designer_studio_sanitize_sortable( $val, $setting ) {
	if ( is_string( $val ) || is_numeric( $val ) ) {
		return array(
			esc_attr( $val ),
		);
	}
	$sanitized_value = array();
	foreach ( $val as $item ) {
		if ( isset( $setting->manager->get_control( $setting->id )->choices[ $item ] ) ) {
			$sanitized_value[] = esc_attr( $item );
		}
	}
	return $sanitized_value;
}

// widgets
function fashion_designer_studio_widgets_init() {
	register_sidebar( array(
		'name'          => __( 'Sidebar', 'fashion-designer-studio' ),
		'id'            => 'sidebar-1',
		'description'   => __( 'Add widgets here to appear in your sidebar on blog posts and archive pages.', 'fashion-designer-studio' ),
		'before_widget' => '<section id="%1$s" class="widget wow zoomIn %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<div class="widget_container"><h3 class="widget-title">',
		'after_title'   => '</h3></div>',
	) );

	register_sidebar( array(
		'name'          => __( 'Page Sidebar', 'fashion-designer-studio' ),
		'id'            => 'sidebar-2',
		'description'   => __( 'Add widgets here to appear in your pages and posts', 'fashion-designer-studio' ),
		'before_widget' => '<section id="%1$s" class="widget wow zoomIn %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<div class="widget_container"><h3 class="widget-title">',
		'after_title'   => '</h3></div>',
	) );

	register_sidebar( array(
		'name'          => __( 'Sidebar 3', 'fashion-designer-studio' ),
		'id'            => 'sidebar-3',
		'description'   => __( 'Add widgets here to appear in your sidebar on blog posts and archive pages.', 'fashion-designer-studio' ),
		'before_widget' => '<section id="%1$s" class="widget wow zoomIn %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<div class="widget_container"><h3 class="widget-title">',
		'after_title'   => '</h3></div>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 1', 'fashion-designer-studio' ),
		'id'            => 'footer-1',
		'description'   => __( 'Add widgets here to appear in your footer.', 'fashion-designer-studio' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 2', 'fashion-designer-studio' ),
		'id'            => 'footer-2',
		'description'   => __( 'Add widgets here to appear in your footer.', 'fashion-designer-studio' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 3', 'fashion-designer-studio' ),
		'id'            => 'footer-3',
		'description'   => __( 'Add widgets here to appear in your footer.', 'fashion-designer-studio' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 4', 'fashion-designer-studio' ),
		'id'            => 'footer-4',
		'description'   => __( 'Add widgets here to appear in your footer.', 'fashion-designer-studio' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );
}
add_action( 'widgets_init', 'fashion_designer_studio_widgets_init' );

function fashion_designer_studio_fonts_url(){
	$font_url = '';
	$font_family = array();
	$font_family[] = 'Heebo:wght@100;200;300;400;500;600;700;800;900';

	$query_args = array(
		'family'	=> rawurlencode(implode('|',$font_family)),
	);
	$font_url = add_query_arg($query_args,'//fonts.googleapis.com/css');
	return $font_url;
	$contents = wptt_get_webfont_url( esc_url_raw( $fonts_url ) );
}

//Enqueue scripts and styles.
function fashion_designer_studio_scripts() {

	// Add custom fonts, used in the main stylesheet.
	wp_enqueue_style( 'fashion-designer-studio-fonts', fashion_designer_studio_fonts_url(), array());

	//Bootstarp
	wp_enqueue_style( 'fashion-designer-studio-bootstrap-style', get_template_directory_uri().'/assets/css/bootstrap.css' );

	// Theme stylesheet.
	wp_enqueue_style( 'fashion-designer-studio-style', get_stylesheet_uri() );

	wp_style_add_data( 'fashion-designer-studio-style', 'rtl', 'replace' );

	// Theme Customize CSS.
	require get_parent_theme_file_path( 'inc/extra_customization.php' );
	wp_add_inline_style( 'fashion-designer-studio-style',$fashion_designer_studio_custom_style );

	//font-awesome
	wp_enqueue_style( 'fashion-designer-studio-font-awesome-style', get_template_directory_uri().'/assets/css/fontawesome-all.css' );

	// Block Style
	wp_enqueue_style( 'fashion-designer-studio-block-style', esc_url( get_template_directory_uri() ).'/assets/css/blocks.css' );

	//Custom JS
	wp_enqueue_script( 'fashion-designer-studio-custom.js', get_theme_file_uri( '/assets/js/theme-script.js' ), array( 'jquery' ), true );

	//Nav Focus JS
	wp_enqueue_script( 'fashion-designer-studio-navigation-focus', get_theme_file_uri( '/assets/js/navigation-focus.js' ), array( 'jquery' ), true );

	//Bootstarp JS
	wp_enqueue_script( 'fashion-designer-studio-bootstrap-js', get_theme_file_uri( '/assets/js/bootstrap.js' ), array( 'jquery' ),true );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}

	if (get_option('fashion_designer_studio_animation_enable', false) !== 'off') {
		//wow.js
		wp_enqueue_script( 'fashion-designer-studio-wow-js', get_theme_file_uri( '/assets/js/wow.js' ), array( 'jquery' ), true );

		//animate.css
		wp_enqueue_style( 'fashion-designer-studio-animate-css', get_template_directory_uri().'/assets/css/animate.css' );
	}
}
add_action( 'wp_enqueue_scripts', 'fashion_designer_studio_scripts' );

// Enqueue editor styles for Gutenberg
function fashion_designer_studio_block_editor_styles() {
	// Block styles.
	wp_enqueue_style( 'fashion-designer-studio-block-editor-style', trailingslashit( esc_url ( get_template_directory_uri() ) ) . '/assets/css/editor-blocks.css' );

	// Add custom fonts.
	wp_enqueue_style( 'fashion-designer-studio-fonts', fashion_designer_studio_fonts_url(), array());
}
add_action( 'enqueue_block_editor_assets', 'fashion_designer_studio_block_editor_styles' );

# Load scripts and styles.(fontawesome)
add_action( 'customize_controls_enqueue_scripts', 'fashion_designer_studio_customize_controls_register_scripts' );

function fashion_designer_studio_customize_controls_register_scripts() {
	
	wp_enqueue_style( 'fashion-designer-studio-ctypo-customize-controls-style', trailingslashit( esc_url(get_template_directory_uri()) ) . '/assets/css/customize-controls.css' );
}

require get_parent_theme_file_path( '/inc/custom-header.php' );
require get_parent_theme_file_path( '/inc/template-tags.php' );
require get_parent_theme_file_path( '/inc/template-functions.php' );
require get_parent_theme_file_path( '/inc/customizer.php' );
require get_parent_theme_file_path( '/inc/typography.php' );
require get_parent_theme_file_path('/inc/wptt-webfont-loader.php' );
require get_parent_theme_file_path( '/inc/breadcrumb.php' );
require_once get_template_directory() . '/inc/admin/welcome-notice.php';
require get_parent_theme_file_path( 'inc/sortable/sortable_control.php' );

//woocommerce plugin skip 
add_filter( 'woocommerce_prevent_automatic_wizard_redirect', '__return_true' );

add_action( 'admin_bar_menu', 'fashion_designer_studio_add_upgrade_button', 100 );

function fashion_designer_studio_add_upgrade_button( $fashion_designer_studio_wp_admin_bar ) {

    $fashion_designer_studio_theme_name = wp_get_theme()->get( 'Name' );

    $fashion_designer_studio_args = array(
        'id'    => 'fashion_designer_studio_upgrade',
        'title' => '<span style="color:#fff;font-weight:600;">
            🚀 Upgrade to ' . esc_html( $fashion_designer_studio_theme_name ) . ' Pro - 20% OFF 
            <span style="background:#ff5722;color:#fff;padding:2px 8px;border-radius:3px;margin-left:6px;">
                Buy Now
            </span>
        </span>',
        'href'  => esc_url( FASHION_DESIGNER_STUDIO_BUY_PRO ),
        'meta'  => array(
            'class'  => 'fashion-designer-studio-upgrade-btn',
            'title'  => 'Upgrade to Pro',
            'target' => '_blank'
        )
    );

    $fashion_designer_studio_wp_admin_bar->add_node( $fashion_designer_studio_args );
}